CEPGP_ST = {
    Enabled = true,
    WrongCEPGPVersion = false,
    RequiredCEPGPVersion = "1.12.18",
    Roster =  {},
    DBConvert = 0
};

CEPGP_ST_Info = {
    Version = "1.1.0"
}

CST_OriginalFunction = nil;

function CST_ListButton_OnClick_hook()
    CST_Original_ListButton_OnClick = CEPGP_ListButton_OnClick;
    CEPGP_ListButton_OnClick = function(obj, button)
        if strfind(obj, "GuildButton") and button == "RightButton" then
            CST_ShowHistory(_G[_G[obj]:GetName() .. "Info"]:GetText());
        else
            CST_Original_ListButton_OnClick(obj, button);
        end
    end
end

function CST_OnEvent(event, ...)

    if event == "ADDON_LOADED" then
		local args = {unpack({...})};
		if args[1] == "CEPGP-StandingsTracker" then
			CST_init();
		end
    end
    
    if event == "GUILD_ROSTER_UPDATE" and CEPGP_ST.Enabled then
        CST_UpdateRoster();
    end
end


function CST_ShowHistory(name)
    CEPGP_ST_History:Show();
    CEPGP_ST_History.id = name;
    CEPGP_ST_History_Title:SetText("EPGP History for: |c"..RAID_CLASS_COLORS[CEPGP_ST.Roster[name][7]].colorStr..name.."|r");
    CEPGP_ST_History_EP_Header:SetPoint("TOPLEFT", CEPGP_ST_History, "TOPLEFT", 15, -(CEPGP_ST_History_Title:GetStringHeight()+25));
    CEPGP_ST_History_GP_Header:SetPoint("TOPLEFT", CEPGP_ST_History, "TOPLEFT", 100, -(CEPGP_ST_History_Title:GetStringHeight()+25));
    CEPGP_ST_History_Date_Header:SetPoint("TOPLEFT", CEPGP_ST_History, "TOPLEFT", 185, -(CEPGP_ST_History_Title:GetStringHeight()+25));
    CST_UpdateHistoryScrollframe(name);
end

function CST_UpdateHistoryScrollframe(name)
    local kids = {_G["CEPGP_ST_History_ScrollFrame_Container"]:GetChildren()};
    local lastEP, lastGP = nil;
    local count = 0;
	for _, child in ipairs(kids) do
		child:Hide();
	end
    for i = #CEPGP_ST.Roster[name][9], 1, -1 do
        count = count + 1;
        local EP;
        local GP;
        local entryDate;
        if type(CEPGP_ST.Roster[name][9][i]) == "table" then
            EP = CEPGP_ST.Roster[name][9][i][1];
            GP = CEPGP_ST.Roster[name][9][i][2];
            entryDate = CEPGP_ST.Roster[name][9][i][3];
        else
            local args = CEPGP_split(CEPGP_ST.Roster[name][9][i],";");
            EP = args[1];
            GP = args[2];
            entryDate = args[3];
        end
        if not _G["CST_History_" ..count] then
            local frame = CreateFrame("BUTTON", "CST_History_"..count,  _G["CEPGP_ST_History_ScrollFrame_Container"], "CEPGP_ST_History_Child");
        end
        if count == 1 then
            _G["CST_History_"..count]:SetPoint("TOPLEFT", _G["CEPGP_ST_History_ScrollFrame_Container"], "TOPLEFT");
        else
            _G["CST_History_"..count]:SetPoint("TOPLEFT", _G["CST_History_"..count-1], "BOTTOMLEFT");
        end
        if not lastEP then
            lastEP = EP
            lastGP = GP
        else
            if lastEP - EP > 0 then
                _G["CST_History_"..(count-1).."_EP"]:SetText(_G["CST_History_"..(count-1).."_EP"]:GetText().."(+"..(lastEP-EP)..")");
            elseif lastEP - EP < 0 then
                _G["CST_History_"..(count-1).."_EP"]:SetText(_G["CST_History_"..(count-1).."_EP"]:GetText().."("..(lastEP-EP)..")");
            end
            if lastGP - GP > 0 then
                _G["CST_History_"..(count-1).."_GP"]:SetText(_G["CST_History_"..(count-1).."_GP"]:GetText().."(+"..(lastGP-GP)..")");
            elseif lastGP - GP < 0 then
                _G["CST_History_"..(count-1).."_GP"]:SetText(_G["CST_History_"..(count-1).."_GP"]:GetText().."("..(lastGP-GP)..")");
            end
            lastEP = EP;
            lastGP = GP;
        end
        _G["CST_History_"..count.."_EP"]:SetText(EP);
        _G["CST_History_"..count.."_GP"]:SetText(GP);
        _G["CST_History_"..count.."_Date"]:SetText(entryDate);
        _G["CST_History_"..count]:Show();
    end
end

function CST_UpdateRoster()
    local quit = false;    
    local limit = GetNumGuildMembers();
    local i = 0;
    local EP = 0;
    local GP = 0;
    
    C_Timer.NewTicker(0.01, function()
        if quit then return; end
        if limit ~= GetNumGuildMembers() then
            quit = true;
            CST_UpdateRoster();
            return;
        end
        i = i + 1;
        local name, rank, rankIndex, _, class, _, _, officerNote, online, _, classFileName, _, _, _, _, _, guid  = GetGuildRosterInfo(i);
        if name then
            name = Ambiguate(name, "all");
            -- Check for name change
            for oldname, olddata in pairs(CEPGP_ST.Roster) do
                if olddata[10] == guid and oldname ~= name then -- name has changed
                    CEPGP_ST.Roster[name] = CEPGP_ST.Roster[oldname];
                    CEPGP_ST.Roster[oldname] = nil;
                end
            end
            if not CEPGP_ST.Roster[name] then
                CEPGP_ST.Roster[name] = {};
            end
            CEPGP_ST.Roster[name][1] = i;
            CEPGP_ST.Roster[name][2] = class;
            CEPGP_ST.Roster[name][3] = rank;
            CEPGP_ST.Roster[name][4] = rankIndex;
            CEPGP_ST.Roster[name][7] = classFileName;
            CEPGP_ST.Roster[name][8] = online;
            if not CEPGP_ST.Roster[name][9] then
                CEPGP_ST.Roster[name][9] = {};
            end
            CEPGP_ST.Roster[name][10] = guid;
            if CEPGP_checkEPGP(officerNote) then
                EP, GP = CEPGP_getEPGP(name, i);
                local OldEP = 0;
                local OldGP = CEPGP.GP.Min;
                if CEPGP_checkEPGP(CEPGP_ST.Roster[name][5]) then
                    OldEP = tonumber(strsub(CEPGP_ST.Roster[name][5], 1, strfind(CEPGP_ST.Roster[name][5], ",")-1));
                    OldGP = tonumber(strsub(CEPGP_ST.Roster[name][5], strfind(CEPGP_ST.Roster[name][5], ",")+1, string.len(CEPGP_ST.Roster[name][5])));
                    OldGP = math.max(math.floor(OldGP), CEPGP.GP.Min);
                end
                if (EP ~= OldEP) or (GP ~= OldGP) then
                    if type(CEPGP_ST.Roster[name][9][1]) == "table" then
                        table.insert(CEPGP_ST.Roster[name][9],{[1] = EP, [2] = GP, [3] = date("%m/%d/%y %H:%M:%S")});
                    else
                        table.insert(CEPGP_ST.Roster[name][9],EP..";"..GP..";"..date("%m/%d/%y %H:%M:%S"));
                    end
                    if CEPGP_ST_History:IsVisible() then
                        CST_UpdateHistoryScrollframe(CEPGP_ST_History.id);
                    end
                elseif #CEPGP_ST.Roster[name][9] == 0 then
                    if CEPGP_ST.DBConvert ~= 1 then
                        table.insert(CEPGP_ST.Roster[name][9],{[1] = EP, [2] = GP, [3] = date("%m/%d/%y %H:%M:%S")});
                    else
                        table.insert(CEPGP_ST.Roster[name][9],EP..";"..GP..";"..date("%m/%d/%y %H:%M:%S"));
                    end
                end
                CEPGP_ST.Roster[name][5] = officerNote;
                CEPGP_ST.Roster[name][6] = math.floor((EP/GP)*100)/100;
            elseif not CEPGP_ST.Roster[name][9][1] then
                officerNote = "0,1";
                EP = 0;
                GP = CEPGP.GP.Min;
                CEPGP_ST.Roster[name][5] = officerNote;
                CEPGP_ST.Roster[name][6] = math.floor((EP/GP)*100)/100;
                if CEPGP_ST.DBConvert ~= 1 then
                    table.insert(CEPGP_ST.Roster[name][9],{[1] = EP, [2] = GP, [3] = date("%m/%d/%y %H:%M:%S")});
                else
                    table.insert(CEPGP_ST.Roster[name][9],EP..";"..GP..";"..date("%m/%d/%y %H:%M:%S"));
                end
            end
        end
    end, limit);
end

function CST_toggle()
    if CEPGP_ST.Enabled then
        CEPGP_ST.Enabled = false;
        CEPGP_ST_History:Hide();
        if not CEPGP_ST.WrongCEPGPVersion then
            CEPGP_UpdateGuildScrollBar = CST_OriginalFunction;
        end
    else  
        CEPGP_ST.Enabled = true;
        if not CEPGP_ST.WrongCEPGPVersion then
            CEPGP_UpdateGuildScrollBar_hook();
        else
            CST_VersionCheck();
        end
    end
end

function CST_VersionCheck()
    local args
    if CEPGP_Info.Version["Number"] then
        args = CEPGP_split(CEPGP_Info.Version["Number"], ".");
    else
        args = CEPGP_split(CEPGP_Info.Version, ".");
    end
    local major = tonumber(args[1]);
	local minor = tonumber(args[2]);
    local revision = tonumber(args[3]);
    if major == 1 and minor == 12 and revision <= 16 then
        CEPGP_ST.WrongCEPGPVersion = true;
        DEFAULT_CHAT_FRAME:AddMessage("|c006969FFCEPGP Standings Tracker: Your installed version of CEPGP is not supported, please update to version 1.12.18 or higher.|r");
    end    
end

function CST_DBConvert()
    for name, v in pairs(CEPGP_ST.Roster) do
        if type(v[9][1]) == "table" then
            local temptable = {};
            for _, entry in ipairs(v[9]) do
                if entry[1] == 0 and entry[2] == CEPGP.GP.Min then
                    -- do nothing
                else
                    table.insert(temptable, entry[1]..";"..entry[2]..";"..entry[3]);
                end
            end
            CEPGP_ST.Roster[name][9] = temptable;
        end
    end
end

function CST_init()
    if CEPGP_ST.Enabled then
        CST_VersionCheck();
    end
    if CEPGP_ST.Enabled and not CEPGP_ST.WrongCEPGPVersion then
        CST_ListButton_OnClick_hook();
    end
    CEPGP_addPlugin("CEPGP-StandingsTracker", nil, CEPGP_ST.Enabled, CST_toggle);
    if not CEPGP_ST.DBConvert then
        print("CEPGP Standings Tracker: Starting database conversion.");
        CST_DBConvert();
        print("CEPGP Standings Tracker: Database conversion complete.");
        CEPGP_ST.DBConvert = 1;
    end
end